asm := Clr_LoadLibrary("EventHelper.dll")
helper := Clr_CreateObject(asm, "EventHelper")
;showinfo(helper, "helper")
forms := Clr_LoadLibrary("System.Windows.Forms")
;showinfo(forms, "forms")
oform := Clr_CreateObject(forms, "System.Windows.Forms.Form")
;showinfo(oform, "oform")

oform.Text := "WinForms in AHK - Take 1"
oform.Width := 400
oform.Height := 400

;;;;
oBtn1 := CLR_CreateObject(forms, "System.Windows.Forms.Button")
oBtn1.Text := "button1"
oBtn1.Width := 60
oBtn1.Height := 30
oBtn1.Left := 100
oBtn1.Top := 100

oBtn2 := CLR_CreateObject(forms, "System.Windows.Forms.Button")
oBtn2.Text := "button2"
oBtn2.Width := 60
oBtn2.Height := 30
oBtn2.Left := oBtn1.Right + 50
oBtn2.Top := oBtn1.Top

helper.AddHandler(oBtn1, "Click", "" RegisterCallback("EventHandler",,, 1))
helper.AddHandler(oBtn2, "Click", "" RegisterCallback("EventHandler",,, 2))

oBtn1.Parent := oForm
oBtn2.Parent := oForm


oform.ShowDialog()
oform.Dispose()
;msgbox done

ExitApp

ShowInfo(object, objname) {
vartype := ComObjType(object)
name := ComObjType(object, "Name")
IID:= ComObjType(object, "IID")
clsid := ComObjType(object, "CLSID")
cname := ComObjtype(object, "Class")
msgbox %objname%'s class is %cname%`r`nName is %name%`r`nCLSID is %clsid%`r`nIID is %IID%`r`n`r`nVT is %vartype%
}

; Our event handler is called with a SAFEARRAY of parameters.  This
; makes it much easier to get the type and value of each parameter.
EventHandler(pprm)
{
    ; Wrap the SAFEARRAY pointer in an object for easy access.
    prm := ComObject(0x200C, pprm)
    ; Show parameters:
    MsgBox, 0, Button Clicked, % "Button #" A_EventInfo " clicked."
}


